/* Generated by re2c 1.1.1 on Tue Nov 13 09:05:21 2018 */
#line 1 "src/parser_scan.re"
/*******************************************************************************
 Copyright (c) 2016, Michael Wallner <mike@php.net>.
 All rights reserved.

 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions are met:

     * Redistributions of source code must retain the above copyright notice,
       this list of conditions and the following disclaimer.
     * Redistributions in binary form must reproduce the above copyright
       notice, this list of conditions and the following disclaimer in the
       documentation and/or other materials provided with the distribution.

 THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE
 FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*******************************************************************************/

#include <php_psi_stdinc.h>

#include "parser.h"
#include "plist.h"

#define YYMAXFILL 15

#ifndef YYMAXFILL
# define YYMAXFILL 256
#endif

size_t psi_parser_maxfill(void) {
	return YYMAXFILL;
}

#define NEWLINE() \
	eol = cur; \
	++I->lines

#define NEWTOKEN(t) do { \
	if (t == PSI_T_COMMENT || t == PSI_T_WHITESPACE) { \
		token = psi_token_init(t, "", 0, tok - eol + 1, I->lines, I->file); \
	} else { \
		token = psi_token_init(t, tok, cur - tok, tok - eol + 1, I->lines, I->file); \
	} \
	tokens = psi_plist_add(tokens, &token); \
	PSI_DEBUG_PRINT(P, "PSI: scanned < "); \
	PSI_DEBUG_DUMP(P, psi_token_dump, token); \
} while(0)

#define CHECKEOF() if (cur >= lim - YYMAXFILL) goto done

struct psi_plist *psi_parser_scan(struct psi_parser *P, struct psi_parser_input *I)
{
	struct psi_plist *tokens;
	struct psi_token *token;
	const char *tok, *cur, *lim, *mrk, *eol, *ctxmrk;
	unsigned parens;
	bool escaped;
	token_t char_width;

	PSI_DEBUG_PRINT(P, "PSI: scanning %s\n", I->file->val);

	tok = mrk = eol = cur = I->buffer;
	lim = I->buffer + I->length + YYMAXFILL;
	I->lines = 1;
	tokens = psi_plist_init((psi_plist_dtor) psi_token_free);

	start: ;
		char_width = 1;
		ctxmrk = NULL;
		tok = cur;

		(void) ctxmrk;

		
#line 85 "src/parser_scan.c"
		{
			unsigned char yych;
			unsigned int yyaccept = 0;
			if ((lim - cur) < 15) CHECKEOF();;
			yych = *cur;
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\v':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case '@':
			case '`':
			case 0x7F:	goto yy2;
			case '\t':
			case '\f':
			case ' ':	goto yy4;
			case '\n':
			case '\r':	goto yy7;
			case '!':	goto yy9;
			case '"':	goto yy11;
			case '#':	goto yy13;
			case '$':	goto yy15;
			case '%':	goto yy16;
			case '&':	goto yy18;
			case '\'':	goto yy20;
			case '(':	goto yy22;
			case ')':	goto yy24;
			case '*':	goto yy26;
			case '+':	goto yy28;
			case ',':	goto yy30;
			case '-':	goto yy32;
			case '.':	goto yy34;
			case '/':	goto yy36;
			case '0':	goto yy38;
			case '1':
			case '2':
			case '3':
			case '4':
			case '5':
			case '6':
			case '7':
			case '8':
			case '9':	goto yy40;
			case ':':	goto yy42;
			case ';':	goto yy44;
			case '<':	goto yy46;
			case '=':	goto yy48;
			case '>':	goto yy50;
			case '?':	goto yy52;
			case 'A':
			case 'a':	goto yy54;
			case 'B':	goto yy56;
			case 'C':	goto yy57;
			case 'D':	goto yy58;
			case 'E':	goto yy59;
			case 'F':	goto yy60;
			case 'I':	goto yy63;
			case 'L':	goto yy64;
			case 'M':
			case 'm':	goto yy65;
			case 'N':
			case 'n':	goto yy66;
			case 'O':
			case 'o':	goto yy67;
			case 'P':	goto yy68;
			case 'R':
			case 'r':	goto yy69;
			case 'S':	goto yy70;
			case 'T':	goto yy71;
			case 'U':	goto yy72;
			case 'W':
			case 'w':	goto yy73;
			case 'Z':
			case 'z':	goto yy74;
			case '[':	goto yy75;
			case '\\':	goto yy77;
			case ']':	goto yy79;
			case '^':	goto yy81;
			case '_':	goto yy83;
			case 'b':	goto yy84;
			case 'c':	goto yy85;
			case 'd':	goto yy86;
			case 'e':	goto yy87;
			case 'f':	goto yy88;
			case 'i':	goto yy89;
			case 'l':	goto yy90;
			case 'p':	goto yy91;
			case 's':	goto yy92;
			case 't':	goto yy93;
			case 'u':	goto yy94;
			case 'v':	goto yy95;
			case '{':	goto yy96;
			case '|':	goto yy98;
			case '}':	goto yy100;
			case '~':	goto yy102;
			default:	goto yy61;
			}
yy2:
			++cur;
yy3:
#line 250 "src/parser_scan.re"
			{ CHECKEOF(); NEWTOKEN(-2); goto error; }
#line 212 "src/parser_scan.c"
yy4:
			++cur;
			if (lim <= cur) CHECKEOF();;
			yych = *cur;
			switch (yych) {
			case '\t':
			case '\f':
			case ' ':	goto yy4;
			default:	goto yy6;
			}
yy6:
#line 249 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_WHITESPACE); goto start; }
#line 226 "src/parser_scan.c"
yy7:
			++cur;
#line 248 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_EOL); NEWLINE(); goto start; }
#line 231 "src/parser_scan.c"
yy9:
			yych = *++cur;
			switch (yych) {
			case '=':	goto yy104;
			default:	goto yy10;
			}
yy10:
#line 151 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_NOT); goto start; }
#line 241 "src/parser_scan.c"
yy11:
			++cur;
#line 124 "src/parser_scan.re"
			{ escaped = false; tok += 1; goto string; }
#line 246 "src/parser_scan.c"
yy13:
			yych = *++cur;
			switch (yych) {
			case '#':	goto yy106;
			default:	goto yy14;
			}
yy14:
#line 134 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_HASH); goto start; }
#line 256 "src/parser_scan.c"
yy15:
			yych = *++cur;
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case '\\':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy3;
			default:	goto yy108;
			}
yy16:
			++cur;
#line 152 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_MODULO); goto start; }
#line 331 "src/parser_scan.c"
yy18:
			yych = *++cur;
			switch (yych) {
			case '&':	goto yy111;
			default:	goto yy19;
			}
yy19:
#line 153 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_AMPERSAND); goto start; }
#line 341 "src/parser_scan.c"
yy20:
			++cur;
#line 123 "src/parser_scan.re"
			{ escaped = false; tok += 1; goto character; }
#line 346 "src/parser_scan.c"
yy22:
			++cur;
#line 135 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_LPAREN); goto start; }
#line 351 "src/parser_scan.c"
yy24:
			++cur;
#line 136 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_RPAREN); goto start; }
#line 356 "src/parser_scan.c"
yy26:
			++cur;
#line 149 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_ASTERISK); goto start; }
#line 361 "src/parser_scan.c"
yy28:
			++cur;
#line 154 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_PLUS); goto start; }
#line 366 "src/parser_scan.c"
yy30:
			++cur;
#line 138 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_COMMA); goto start; }
#line 371 "src/parser_scan.c"
yy32:
			++cur;
#line 155 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_MINUS); goto start; }
#line 376 "src/parser_scan.c"
yy34:
			yyaccept = 0;
			yych = *(mrk = ++cur);
			switch (yych) {
			case '.':	goto yy113;
			case '0':
			case '1':
			case '2':
			case '3':
			case '4':
			case '5':
			case '6':
			case '7':
			case '8':
			case '9':	goto yy115;
			default:	goto yy35;
			}
yy35:
#line 166 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_PERIOD); goto start; }
#line 397 "src/parser_scan.c"
yy36:
			yych = *++cur;
			switch (yych) {
			case '*':	goto yy118;
			case '/':	goto yy120;
			default:	goto yy37;
			}
yy37:
#line 156 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_SLASH); goto start; }
#line 408 "src/parser_scan.c"
yy38:
			yyaccept = 1;
			yych = *(mrk = ++cur);
			switch (yych) {
			case '.':	goto yy122;
			case 'E':
			case 'e':	goto yy126;
			case 'X':
			case 'x':	goto yy131;
			default:	goto yy125;
			}
yy39:
#line 110 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_NUMBER); token->flags = PSI_NUMBER_INT; goto start; }
#line 423 "src/parser_scan.c"
yy40:
			yyaccept = 1;
			mrk = ++cur;
			if ((lim - cur) < 3) CHECKEOF();;
			yych = *cur;
			switch (yych) {
			case '.':	goto yy122;
			case '0':
			case '1':
			case '2':
			case '3':
			case '4':
			case '5':
			case '6':
			case '7':
			case '8':
			case '9':	goto yy40;
			case 'E':
			case 'e':	goto yy126;
			case 'L':
			case 'l':	goto yy127;
			case 'U':
			case 'u':	goto yy129;
			default:	goto yy39;
			}
yy42:
			++cur;
#line 139 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_COLON); goto start; }
#line 453 "src/parser_scan.c"
yy44:
			++cur;
#line 137 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_EOS); goto start; }
#line 458 "src/parser_scan.c"
yy46:
			yyaccept = 2;
			yych = *(mrk = ++cur);
			switch (yych) {
			case '-':
			case '.':
			case '/':
			case '0':
			case '1':
			case '2':
			case '3':
			case '4':
			case '5':
			case '6':
			case '7':
			case '8':
			case '9':
			case 'A':
			case 'B':
			case 'C':
			case 'D':
			case 'E':
			case 'F':
			case 'G':
			case 'H':
			case 'I':
			case 'J':
			case 'K':
			case 'L':
			case 'M':
			case 'N':
			case 'O':
			case 'P':
			case 'Q':
			case 'R':
			case 'S':
			case 'T':
			case 'U':
			case 'V':
			case 'W':
			case 'X':
			case 'Y':
			case 'Z':
			case '_':
			case 'a':
			case 'b':
			case 'c':
			case 'd':
			case 'e':
			case 'f':
			case 'g':
			case 'h':
			case 'i':
			case 'j':
			case 'k':
			case 'l':
			case 'm':
			case 'n':
			case 'o':
			case 'p':
			case 'q':
			case 'r':
			case 's':
			case 't':
			case 'u':
			case 'v':
			case 'w':
			case 'x':
			case 'y':
			case 'z':	goto yy132;
			case '<':	goto yy134;
			case '=':	goto yy136;
			default:	goto yy47;
			}
yy47:
#line 164 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_LCHEVR); goto start; }
#line 536 "src/parser_scan.c"
yy48:
			yych = *++cur;
			switch (yych) {
			case '=':	goto yy138;
			default:	goto yy49;
			}
yy49:
#line 148 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_EQUALS); goto start; }
#line 546 "src/parser_scan.c"
yy50:
			yych = *++cur;
			switch (yych) {
			case '=':	goto yy140;
			case '>':	goto yy142;
			default:	goto yy51;
			}
yy51:
#line 165 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_RCHEVR); goto start; }
#line 557 "src/parser_scan.c"
yy52:
			++cur;
#line 168 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_IIF); goto start; }
#line 562 "src/parser_scan.c"
yy54:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'R':
			case 'r':	goto yy144;
			case 'S':
			case 's':	goto yy145;
			default:	goto yy62;
			}
yy55:
#line 243 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_NAME); goto start; }
#line 576 "src/parser_scan.c"
yy56:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'O':
			case 'o':	goto yy148;
			default:	goto yy62;
			}
yy57:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'A':
			case 'a':	goto yy149;
			case 'O':
			case 'o':	goto yy150;
			default:	goto yy62;
			}
yy58:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'E':
			case 'e':	goto yy151;
			default:	goto yy62;
			}
yy59:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'L':
			case 'l':	goto yy152;
			case 'N':
			case 'n':	goto yy153;
			case 'R':
			case 'r':	goto yy154;
			default:	goto yy62;
			}
yy60:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'A':
			case 'a':	goto yy155;
			case 'L':
			case 'l':	goto yy156;
			case 'R':
			case 'r':	goto yy157;
			case 'U':
			case 'u':	goto yy158;
			default:	goto yy62;
			}
yy61:
			yyaccept = 3;
			mrk = ++cur;
			if (lim <= cur) CHECKEOF();;
			yych = *cur;
yy62:
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy55;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy63:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'F':
			case 'f':	goto yy159;
			case 'N':
			case 'n':	goto yy161;
			default:	goto yy62;
			}
yy64:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case '"':
			case '\'':	goto yy162;
			case 'E':
			case 'e':	goto yy164;
			case 'I':
			case 'i':	goto yy165;
			default:	goto yy62;
			}
yy65:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'I':
			case 'i':	goto yy166;
			default:	goto yy62;
			}
yy66:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'U':
			case 'u':	goto yy167;
			default:	goto yy62;
			}
yy67:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'B':
			case 'b':	goto yy168;
			default:	goto yy62;
			}
yy68:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'A':
			case 'a':	goto yy169;
			case 'O':
			case 'o':	goto yy170;
			case 'R':
			case 'r':	goto yy171;
			default:	goto yy62;
			}
yy69:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'E':
			case 'e':	goto yy172;
			default:	goto yy62;
			}
yy70:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'E':
			case 'e':	goto yy173;
			case 'T':
			case 't':	goto yy174;
			default:	goto yy62;
			}
yy71:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'E':
			case 'e':	goto yy175;
			case 'O':
			case 'o':	goto yy176;
			case 'R':
			case 'r':	goto yy177;
			default:	goto yy62;
			}
yy72:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case '"':
			case '\'':	goto yy178;
			case 'N':
			case 'n':	goto yy180;
			default:	goto yy62;
			}
yy73:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'A':
			case 'a':	goto yy181;
			default:	goto yy62;
			}
yy74:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'V':
			case 'v':	goto yy182;
			default:	goto yy62;
			}
yy75:
			++cur;
#line 142 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_LBRACKET); goto start; }
#line 821 "src/parser_scan.c"
yy77:
			yych = *++cur;
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case '0':
			case '1':
			case '2':
			case '3':
			case '4':
			case '5':
			case '6':
			case '7':
			case '8':
			case '9':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case '\\':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy78;
			default:	goto yy183;
			}
yy78:
#line 157 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_BSLASH); goto start; }
#line 905 "src/parser_scan.c"
yy79:
			++cur;
#line 143 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_RBRACKET); goto start; }
#line 910 "src/parser_scan.c"
yy81:
			++cur;
#line 159 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_CARET); goto start; }
#line 915 "src/parser_scan.c"
yy83:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case '_':	goto yy186;
			default:	goto yy62;
			}
yy84:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'O':	goto yy148;
			case 'o':	goto yy187;
			default:	goto yy62;
			}
yy85:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'A':
			case 'a':	goto yy149;
			case 'O':	goto yy150;
			case 'h':	goto yy188;
			case 'o':	goto yy189;
			default:	goto yy62;
			}
yy86:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'E':
			case 'e':	goto yy151;
			case 'o':	goto yy190;
			default:	goto yy62;
			}
yy87:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'L':
			case 'l':	goto yy152;
			case 'N':	goto yy153;
			case 'R':
			case 'r':	goto yy154;
			case 'n':	goto yy191;
			default:	goto yy62;
			}
yy88:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'A':
			case 'a':	goto yy155;
			case 'L':	goto yy156;
			case 'R':
			case 'r':	goto yy157;
			case 'U':
			case 'u':	goto yy158;
			case 'l':	goto yy192;
			default:	goto yy62;
			}
yy89:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'F':
			case 'f':	goto yy159;
			case 'N':	goto yy161;
			case 'n':	goto yy193;
			default:	goto yy62;
			}
yy90:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'E':
			case 'e':	goto yy164;
			case 'I':	goto yy165;
			case 'i':	goto yy194;
			case 'o':	goto yy195;
			default:	goto yy62;
			}
yy91:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'A':
			case 'a':	goto yy169;
			case 'O':
			case 'o':	goto yy170;
			case 'R':	goto yy171;
			case 'r':	goto yy196;
			default:	goto yy62;
			}
yy92:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'E':
			case 'e':	goto yy173;
			case 'T':	goto yy174;
			case 'h':	goto yy197;
			case 'i':	goto yy198;
			case 't':	goto yy199;
			default:	goto yy62;
			}
yy93:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'E':
			case 'e':	goto yy175;
			case 'O':
			case 'o':	goto yy176;
			case 'R':
			case 'r':	goto yy177;
			case 'y':	goto yy200;
			default:	goto yy62;
			}
yy94:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case '"':
			case '\'':	goto yy201;
			case '8':	goto yy203;
			case 'N':	goto yy180;
			case 'n':	goto yy204;
			default:	goto yy62;
			}
yy95:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'o':	goto yy205;
			default:	goto yy62;
			}
yy96:
			++cur;
#line 140 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_LBRACE); goto start; }
#line 1057 "src/parser_scan.c"
yy98:
			yych = *++cur;
			switch (yych) {
			case '|':	goto yy206;
			default:	goto yy99;
			}
yy99:
#line 158 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_PIPE); goto start; }
#line 1067 "src/parser_scan.c"
yy100:
			++cur;
#line 141 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_RBRACE); goto start; }
#line 1072 "src/parser_scan.c"
yy102:
			++cur;
#line 150 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_TILDE); goto start; }
#line 1077 "src/parser_scan.c"
yy104:
			++cur;
#line 144 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_CMP_NE); goto start; }
#line 1082 "src/parser_scan.c"
yy106:
			++cur;
#line 133 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_CPP_PASTE); goto start; }
#line 1087 "src/parser_scan.c"
yy108:
			++cur;
			if (lim <= cur) CHECKEOF();;
			yych = *cur;
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case '\\':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy110;
			default:	goto yy108;
			}
yy110:
#line 245 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_DOLLAR_NAME); goto start; }
#line 1163 "src/parser_scan.c"
yy111:
			++cur;
#line 146 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_AND); goto start; }
#line 1168 "src/parser_scan.c"
yy113:
			yych = *++cur;
			switch (yych) {
			case '.':	goto yy208;
			default:	goto yy114;
			}
yy114:
			cur = mrk;
			switch (yyaccept) {
			case 0: 	goto yy35;
			case 1: 	goto yy39;
			case 2: 	goto yy47;
			case 3: 	goto yy55;
			case 4: 	goto yy117;
			case 5: 	goto yy128;
			case 6: 	goto yy146;
			case 7: 	goto yy160;
			case 8: 	goto yy185;
			case 9: 	goto yy242;
			case 10: 	goto yy244;
			case 11: 	goto yy253;
			case 12: 	goto yy274;
			case 13: 	goto yy306;
			case 14: 	goto yy308;
			case 15: 	goto yy314;
			case 16: 	goto yy322;
			case 17: 	goto yy334;
			case 18: 	goto yy342;
			case 19: 	goto yy346;
			case 20: 	goto yy353;
			case 21: 	goto yy355;
			case 22: 	goto yy359;
			case 23: 	goto yy363;
			case 24: 	goto yy365;
			case 25: 	goto yy375;
			case 26: 	goto yy378;
			case 27: 	goto yy385;
			case 28: 	goto yy388;
			case 29: 	goto yy390;
			case 30: 	goto yy392;
			case 31: 	goto yy396;
			case 32: 	goto yy401;
			case 33: 	goto yy419;
			case 34: 	goto yy422;
			case 35: 	goto yy427;
			case 36: 	goto yy430;
			case 37: 	goto yy434;
			case 38: 	goto yy440;
			case 39: 	goto yy444;
			case 40: 	goto yy449;
			case 41: 	goto yy451;
			case 42: 	goto yy455;
			case 43: 	goto yy458;
			case 44: 	goto yy460;
			case 45: 	goto yy462;
			case 46: 	goto yy467;
			case 47: 	goto yy469;
			case 48: 	goto yy471;
			case 49: 	goto yy473;
			case 50: 	goto yy475;
			case 51: 	goto yy480;
			case 52: 	goto yy489;
			case 53: 	goto yy491;
			case 54: 	goto yy493;
			case 55: 	goto yy495;
			case 56: 	goto yy497;
			case 57: 	goto yy499;
			case 58: 	goto yy504;
			case 59: 	goto yy508;
			case 60: 	goto yy512;
			case 61: 	goto yy514;
			case 62: 	goto yy519;
			case 63: 	goto yy524;
			case 64: 	goto yy532;
			case 65: 	goto yy536;
			case 66: 	goto yy538;
			case 67: 	goto yy540;
			case 68: 	goto yy542;
			case 69: 	goto yy547;
			case 70: 	goto yy549;
			case 71: 	goto yy558;
			case 72: 	goto yy560;
			case 73: 	goto yy565;
			case 74: 	goto yy567;
			case 75: 	goto yy575;
			case 76: 	goto yy579;
			case 77: 	goto yy583;
			case 78: 	goto yy587;
			case 79: 	goto yy589;
			default:	goto yy594;
			}
yy115:
			yyaccept = 4;
			mrk = ++cur;
			if ((lim - cur) < 2) CHECKEOF();;
			yych = *cur;
			switch (yych) {
			case '0':
			case '1':
			case '2':
			case '3':
			case '4':
			case '5':
			case '6':
			case '7':
			case '8':
			case '9':	goto yy115;
			case 'D':
			case 'd':	goto yy210;
			case 'F':
			case 'f':	goto yy211;
			case 'L':
			case 'l':	goto yy213;
			default:	goto yy117;
			}
yy117:
#line 116 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_NUMBER); token->flags = PSI_NUMBER_FLT; goto start; }
#line 1287 "src/parser_scan.c"
yy118:
			++cur;
#line 130 "src/parser_scan.re"
			{ goto comment; }
#line 1292 "src/parser_scan.c"
yy120:
			++cur;
#line 131 "src/parser_scan.re"
			{ goto comment_sl; }
#line 1297 "src/parser_scan.c"
yy122:
			yyaccept = 4;
			mrk = ++cur;
			if ((lim - cur) < 3) CHECKEOF();;
			yych = *cur;
			switch (yych) {
			case '0':
			case '1':
			case '2':
			case '3':
			case '4':
			case '5':
			case '6':
			case '7':
			case '8':
			case '9':	goto yy122;
			case 'D':
			case 'd':	goto yy210;
			case 'E':
			case 'e':	goto yy126;
			case 'F':
			case 'f':	goto yy211;
			case 'L':
			case 'l':	goto yy213;
			default:	goto yy117;
			}
yy124:
			++cur;
			if ((lim - cur) < 3) CHECKEOF();;
			yych = *cur;
yy125:
			switch (yych) {
			case '0':
			case '1':
			case '2':
			case '3':
			case '4':
			case '5':
			case '6':
			case '7':	goto yy124;
			case 'L':
			case 'l':	goto yy127;
			case 'U':
			case 'u':	goto yy129;
			default:	goto yy39;
			}
yy126:
			yych = *++cur;
			switch (yych) {
			case '+':
			case '-':	goto yy215;
			case '0':
			case '1':
			case '2':
			case '3':
			case '4':
			case '5':
			case '6':
			case '7':
			case '8':
			case '9':	goto yy115;
			default:	goto yy114;
			}
yy127:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'L':
			case 'l':	goto yy216;
			case 'U':
			case 'u':	goto yy217;
			default:	goto yy128;
			}
yy128:
			cur -= 1;
#line 112 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_NUMBER); token->flags = PSI_NUMBER_INT | PSI_NUMBER_L; cur += 1; goto start; }
#line 1375 "src/parser_scan.c"
yy129:
			yych = *++cur;
			switch (yych) {
			case 'L':
			case 'l':	goto yy219;
			default:	goto yy130;
			}
yy130:
			cur -= 1;
#line 111 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_NUMBER); token->flags = PSI_NUMBER_INT | PSI_NUMBER_U; cur += 1; goto start; }
#line 1387 "src/parser_scan.c"
yy131:
			yych = *++cur;
			switch (yych) {
			case '0':
			case '1':
			case '2':
			case '3':
			case '4':
			case '5':
			case '6':
			case '7':
			case '8':
			case '9':
			case 'A':
			case 'B':
			case 'C':
			case 'D':
			case 'E':
			case 'F':
			case 'a':
			case 'b':
			case 'c':
			case 'd':
			case 'e':
			case 'f':	goto yy220;
			default:	goto yy114;
			}
yy132:
			++cur;
			if (lim <= cur) CHECKEOF();;
			yych = *cur;
			switch (yych) {
			case '-':
			case '.':
			case '/':
			case '0':
			case '1':
			case '2':
			case '3':
			case '4':
			case '5':
			case '6':
			case '7':
			case '8':
			case '9':
			case 'A':
			case 'B':
			case 'C':
			case 'D':
			case 'E':
			case 'F':
			case 'G':
			case 'H':
			case 'I':
			case 'J':
			case 'K':
			case 'L':
			case 'M':
			case 'N':
			case 'O':
			case 'P':
			case 'Q':
			case 'R':
			case 'S':
			case 'T':
			case 'U':
			case 'V':
			case 'W':
			case 'X':
			case 'Y':
			case 'Z':
			case '_':
			case 'a':
			case 'b':
			case 'c':
			case 'd':
			case 'e':
			case 'f':
			case 'g':
			case 'h':
			case 'i':
			case 'j':
			case 'k':
			case 'l':
			case 'm':
			case 'n':
			case 'o':
			case 'p':
			case 'q':
			case 'r':
			case 's':
			case 't':
			case 'u':
			case 'v':
			case 'w':
			case 'x':
			case 'y':
			case 'z':	goto yy132;
			case '>':	goto yy222;
			default:	goto yy114;
			}
yy134:
			++cur;
#line 160 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_LSHIFT); goto start; }
#line 1493 "src/parser_scan.c"
yy136:
			++cur;
#line 162 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_CMP_LE); goto start; }
#line 1498 "src/parser_scan.c"
yy138:
			++cur;
#line 145 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_CMP_EQ); goto start; }
#line 1503 "src/parser_scan.c"
yy140:
			++cur;
#line 163 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_CMP_GE); goto start; }
#line 1508 "src/parser_scan.c"
yy142:
			++cur;
#line 161 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_RSHIFT); goto start; }
#line 1513 "src/parser_scan.c"
yy144:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'R':
			case 'r':	goto yy224;
			default:	goto yy62;
			}
yy145:
			yyaccept = 6;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy146;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy146:
#line 223 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_AS); goto start; }
#line 1596 "src/parser_scan.c"
yy147:
			++cur;
			if (lim <= cur) CHECKEOF();;
			yych = *cur;
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case '0':
			case '1':
			case '2':
			case '3':
			case '4':
			case '5':
			case '6':
			case '7':
			case '8':
			case '9':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case '\\':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy114;
			default:	goto yy183;
			}
yy148:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'O':
			case 'o':	goto yy225;
			default:	goto yy62;
			}
yy149:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'L':
			case 'l':	goto yy226;
			default:	goto yy62;
			}
yy150:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'U':
			case 'u':	goto yy227;
			default:	goto yy62;
			}
yy151:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'F':
			case 'f':	goto yy228;
			default:	goto yy62;
			}
yy152:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'I':
			case 'i':	goto yy229;
			case 'S':
			case 's':	goto yy230;
			default:	goto yy62;
			}
yy153:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'D':
			case 'd':	goto yy231;
			default:	goto yy62;
			}
yy154:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'R':
			case 'r':	goto yy232;
			default:	goto yy62;
			}
yy155:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'L':
			case 'l':	goto yy233;
			default:	goto yy62;
			}
yy156:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'O':
			case 'o':	goto yy234;
			default:	goto yy62;
			}
yy157:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'E':
			case 'e':	goto yy235;
			default:	goto yy62;
			}
yy158:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'N':
			case 'n':	goto yy236;
			default:	goto yy62;
			}
yy159:
			yyaccept = 7;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy160;
			case 'D':
			case 'd':	goto yy237;
			case 'N':
			case 'n':	goto yy238;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy160:
#line 193 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_IF); goto start; }
#line 1847 "src/parser_scan.c"
yy161:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'C':
			case 'c':	goto yy239;
			case 'T':
			case 't':	goto yy240;
			default:	goto yy62;
			}
yy162:
			++cur;
			cur -= 1;
#line 128 "src/parser_scan.re"
			{ char_width = sizeof(wchar_t)/8; }
#line 1863 "src/parser_scan.c"
yy164:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'T':
			case 't':	goto yy241;
			default:	goto yy62;
			}
yy165:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'B':
			case 'b':	goto yy243;
			default:	goto yy62;
			}
yy166:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'X':
			case 'x':	goto yy245;
			default:	goto yy62;
			}
yy167:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'L':
			case 'l':	goto yy246;
			default:	goto yy62;
			}
yy168:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'J':
			case 'j':	goto yy247;
			default:	goto yy62;
			}
yy169:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'T':
			case 't':	goto yy248;
			default:	goto yy62;
			}
yy170:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'S':
			case 's':	goto yy249;
			default:	goto yy62;
			}
yy171:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'E':
			case 'e':	goto yy250;
			default:	goto yy62;
			}
yy172:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'T':
			case 't':	goto yy251;
			default:	goto yy62;
			}
yy173:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'T':
			case 't':	goto yy252;
			default:	goto yy62;
			}
yy174:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'A':
			case 'a':	goto yy254;
			case 'R':
			case 'r':	goto yy255;
			default:	goto yy62;
			}
yy175:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'M':
			case 'm':	goto yy256;
			default:	goto yy62;
			}
yy176:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case '_':	goto yy257;
			default:	goto yy62;
			}
yy177:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'U':
			case 'u':	goto yy258;
			default:	goto yy62;
			}
yy178:
			++cur;
			cur -= 1;
#line 127 "src/parser_scan.re"
			{ char_width = 4; }
#line 1982 "src/parser_scan.c"
yy180:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'D':
			case 'd':	goto yy259;
			default:	goto yy62;
			}
yy181:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'R':
			case 'r':	goto yy260;
			default:	goto yy62;
			}
yy182:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'A':
			case 'a':	goto yy261;
			default:	goto yy62;
			}
yy183:
			yyaccept = 8;
			mrk = ++cur;
			if (lim <= cur) CHECKEOF();;
			yych = *cur;
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy185;
			case '\\':	goto yy147;
			default:	goto yy183;
			}
yy185:
#line 244 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_NSNAME); goto start; }
#line 2083 "src/parser_scan.c"
yy186:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'a':	goto yy262;
			case 'e':	goto yy263;
			case 'i':	goto yy264;
			case 'r':	goto yy265;
			default:	goto yy62;
			}
yy187:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'O':	goto yy225;
			case 'o':	goto yy266;
			default:	goto yy62;
			}
yy188:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'a':	goto yy267;
			default:	goto yy62;
			}
yy189:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'U':
			case 'u':	goto yy227;
			case 'n':	goto yy268;
			default:	goto yy62;
			}
yy190:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'u':	goto yy269;
			default:	goto yy62;
			}
yy191:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'D':
			case 'd':	goto yy231;
			case 'u':	goto yy270;
			default:	goto yy62;
			}
yy192:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'O':	goto yy234;
			case 'o':	goto yy271;
			default:	goto yy62;
			}
yy193:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'C':
			case 'c':	goto yy239;
			case 'T':	goto yy240;
			case 'l':	goto yy272;
			case 't':	goto yy273;
			default:	goto yy62;
			}
yy194:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'B':
			case 'b':	goto yy243;
			case 'n':	goto yy275;
			default:	goto yy62;
			}
yy195:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'n':	goto yy276;
			default:	goto yy62;
			}
yy196:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'E':
			case 'e':	goto yy250;
			case 'a':	goto yy277;
			default:	goto yy62;
			}
yy197:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'o':	goto yy278;
			default:	goto yy62;
			}
yy198:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'g':	goto yy279;
			case 'z':	goto yy280;
			default:	goto yy62;
			}
yy199:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'A':
			case 'a':	goto yy254;
			case 'R':	goto yy255;
			case 'r':	goto yy281;
			default:	goto yy62;
			}
yy200:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'p':	goto yy282;
			default:	goto yy62;
			}
yy201:
			++cur;
			cur -= 1;
#line 126 "src/parser_scan.re"
			{ char_width = 2; }
#line 2215 "src/parser_scan.c"
yy203:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case '"':	goto yy283;
			default:	goto yy62;
			}
yy204:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'D':
			case 'd':	goto yy259;
			case 'i':	goto yy285;
			case 's':	goto yy286;
			default:	goto yy62;
			}
yy205:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'i':	goto yy287;
			case 'l':	goto yy288;
			default:	goto yy62;
			}
yy206:
			++cur;
#line 147 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_OR); goto start; }
#line 2245 "src/parser_scan.c"
yy208:
			++cur;
#line 167 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_ELLIPSIS); goto start; }
#line 2250 "src/parser_scan.c"
yy210:
			yych = *++cur;
			switch (yych) {
			case 'D':
			case 'd':	goto yy289;
			case 'F':
			case 'f':	goto yy291;
			case 'L':
			case 'l':	goto yy293;
			default:	goto yy114;
			}
yy211:
			++cur;
			cur -= 1;
#line 117 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_NUMBER); token->flags = PSI_NUMBER_FLT | PSI_NUMBER_F; cur += 1; goto start; }
#line 2267 "src/parser_scan.c"
yy213:
			++cur;
			cur -= 1;
#line 118 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_NUMBER); token->flags = PSI_NUMBER_FLT | PSI_NUMBER_L; cur += 1; goto start; }
#line 2273 "src/parser_scan.c"
yy215:
			yych = *++cur;
			switch (yych) {
			case '0':
			case '1':
			case '2':
			case '3':
			case '4':
			case '5':
			case '6':
			case '7':
			case '8':
			case '9':	goto yy115;
			default:	goto yy114;
			}
yy216:
			yych = *++cur;
			switch (yych) {
			case 'U':
			case 'u':	goto yy295;
			default:	goto yy114;
			}
yy217:
			++cur;
yy218:
			cur -= 2;
#line 113 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_NUMBER); token->flags = PSI_NUMBER_INT | PSI_NUMBER_UL; cur += 2; goto start; }
#line 2302 "src/parser_scan.c"
yy219:
			yych = *++cur;
			switch (yych) {
			case 'L':
			case 'l':	goto yy295;
			default:	goto yy218;
			}
yy220:
			yyaccept = 1;
			mrk = ++cur;
			if ((lim - cur) < 3) CHECKEOF();;
			yych = *cur;
			switch (yych) {
			case '.':	goto yy297;
			case '0':
			case '1':
			case '2':
			case '3':
			case '4':
			case '5':
			case '6':
			case '7':
			case '8':
			case '9':
			case 'A':
			case 'B':
			case 'C':
			case 'D':
			case 'E':
			case 'F':
			case 'a':
			case 'b':
			case 'c':
			case 'd':
			case 'e':
			case 'f':	goto yy220;
			case 'L':
			case 'l':	goto yy127;
			case 'P':
			case 'p':	goto yy126;
			case 'U':
			case 'u':	goto yy129;
			default:	goto yy39;
			}
yy222:
			++cur;
#line 246 "src/parser_scan.re"
			{ tok += 1; cur -= 1; NEWTOKEN(PSI_T_CPP_HEADER); cur += 1; goto start; }
#line 2351 "src/parser_scan.c"
yy224:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'A':
			case 'a':	goto yy299;
			case 'V':
			case 'v':	goto yy300;
			default:	goto yy62;
			}
yy225:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'L':
			case 'l':	goto yy301;
			default:	goto yy62;
			}
yy226:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'L':
			case 'l':	goto yy302;
			default:	goto yy62;
			}
yy227:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'N':
			case 'n':	goto yy303;
			default:	goto yy62;
			}
yy228:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'I':
			case 'i':	goto yy304;
			default:	goto yy62;
			}
yy229:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'F':
			case 'f':	goto yy305;
			default:	goto yy62;
			}
yy230:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'E':
			case 'e':	goto yy307;
			default:	goto yy62;
			}
yy231:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'I':
			case 'i':	goto yy309;
			default:	goto yy62;
			}
yy232:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'O':
			case 'o':	goto yy310;
			default:	goto yy62;
			}
yy233:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'S':
			case 's':	goto yy311;
			default:	goto yy62;
			}
yy234:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'A':
			case 'a':	goto yy312;
			default:	goto yy62;
			}
yy235:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'E':
			case 'e':	goto yy313;
			default:	goto yy62;
			}
yy236:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'C':
			case 'c':	goto yy315;
			default:	goto yy62;
			}
yy237:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'E':
			case 'e':	goto yy316;
			default:	goto yy62;
			}
yy238:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'D':
			case 'd':	goto yy317;
			default:	goto yy62;
			}
yy239:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'L':
			case 'l':	goto yy318;
			default:	goto yy62;
			}
yy240:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'V':
			case 'v':	goto yy319;
			default:	goto yy62;
			}
yy241:
			yyaccept = 9;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy242;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy242:
#line 218 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_LET); goto start; }
#line 2564 "src/parser_scan.c"
yy243:
			yyaccept = 10;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy244;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy244:
#line 217 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_LIB); goto start; }
#line 2639 "src/parser_scan.c"
yy245:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'E':
			case 'e':	goto yy320;
			default:	goto yy62;
			}
yy246:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'L':
			case 'l':	goto yy321;
			default:	goto yy62;
			}
yy247:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'E':
			case 'e':	goto yy323;
			case 'V':
			case 'v':	goto yy324;
			default:	goto yy62;
			}
yy248:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'H':
			case 'h':	goto yy325;
			default:	goto yy62;
			}
yy249:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'T':
			case 't':	goto yy326;
			default:	goto yy62;
			}
yy250:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case '_':	goto yy327;
			default:	goto yy62;
			}
yy251:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'U':
			case 'u':	goto yy328;
			default:	goto yy62;
			}
yy252:
			yyaccept = 11;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy253;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy253:
#line 219 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_SET); goto start; }
#line 2771 "src/parser_scan.c"
yy254:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'T':
			case 't':	goto yy329;
			default:	goto yy62;
			}
yy255:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'I':
			case 'i':	goto yy330;
			case 'L':
			case 'l':	goto yy331;
			case 'V':
			case 'v':	goto yy332;
			default:	goto yy62;
			}
yy256:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'P':
			case 'p':	goto yy333;
			default:	goto yy62;
			}
yy257:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'A':
			case 'a':	goto yy335;
			case 'B':
			case 'b':	goto yy336;
			case 'F':
			case 'f':	goto yy337;
			case 'I':
			case 'i':	goto yy338;
			case 'O':
			case 'o':	goto yy339;
			case 'S':
			case 's':	goto yy340;
			default:	goto yy62;
			}
yy258:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'E':
			case 'e':	goto yy341;
			default:	goto yy62;
			}
yy259:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'E':
			case 'e':	goto yy343;
			default:	goto yy62;
			}
yy260:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'N':
			case 'n':	goto yy344;
			default:	goto yy62;
			}
yy261:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'L':
			case 'l':	goto yy345;
			default:	goto yy62;
			}
yy262:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 's':	goto yy347;
			case 't':	goto yy348;
			default:	goto yy62;
			}
yy263:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'x':	goto yy349;
			default:	goto yy62;
			}
yy264:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'n':	goto yy350;
			default:	goto yy62;
			}
yy265:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'e':	goto yy351;
			default:	goto yy62;
			}
yy266:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'L':	goto yy301;
			case 'l':	goto yy352;
			default:	goto yy62;
			}
yy267:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'r':	goto yy354;
			default:	goto yy62;
			}
yy268:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 's':	goto yy356;
			default:	goto yy62;
			}
yy269:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'b':	goto yy357;
			default:	goto yy62;
			}
yy270:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'm':	goto yy358;
			default:	goto yy62;
			}
yy271:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'A':	goto yy312;
			case 'a':	goto yy360;
			default:	goto yy62;
			}
yy272:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'i':	goto yy361;
			default:	goto yy62;
			}
yy273:
			yyaccept = 12;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy274;
			case 'V':
			case 'v':	goto yy319;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy274:
#line 187 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_INT); goto start; }
#line 3006 "src/parser_scan.c"
yy275:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'e':	goto yy362;
			default:	goto yy62;
			}
yy276:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'g':	goto yy364;
			default:	goto yy62;
			}
yy277:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'g':	goto yy366;
			default:	goto yy62;
			}
yy278:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'r':	goto yy367;
			default:	goto yy62;
			}
yy279:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'n':	goto yy368;
			default:	goto yy62;
			}
yy280:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'e':	goto yy369;
			default:	goto yy62;
			}
yy281:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'I':
			case 'i':	goto yy330;
			case 'L':
			case 'l':	goto yy331;
			case 'V':
			case 'v':	goto yy332;
			case 'u':	goto yy370;
			default:	goto yy62;
			}
yy282:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'e':	goto yy371;
			default:	goto yy62;
			}
yy283:
			++cur;
			cur -= 1;
#line 125 "src/parser_scan.re"
			{ char_width = 1; }
#line 3074 "src/parser_scan.c"
yy285:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'o':	goto yy372;
			default:	goto yy62;
			}
yy286:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'i':	goto yy373;
			default:	goto yy62;
			}
yy287:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'd':	goto yy374;
			default:	goto yy62;
			}
yy288:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'a':	goto yy376;
			default:	goto yy62;
			}
yy289:
			++cur;
			cur -= 2;
#line 120 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_NUMBER); token->flags = PSI_NUMBER_FLT | PSI_NUMBER_DD; cur += 2; goto start; }
#line 3108 "src/parser_scan.c"
yy291:
			++cur;
			cur -= 2;
#line 119 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_NUMBER); token->flags = PSI_NUMBER_FLT | PSI_NUMBER_DF; cur += 2; goto start; }
#line 3114 "src/parser_scan.c"
yy293:
			++cur;
			cur -= 2;
#line 121 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_NUMBER); token->flags = PSI_NUMBER_FLT | PSI_NUMBER_DL; cur += 2; goto start; }
#line 3120 "src/parser_scan.c"
yy295:
			++cur;
			cur -= 3;
#line 114 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_NUMBER); token->flags = PSI_NUMBER_INT | PSI_NUMBER_ULL; cur += 3; goto start; }
#line 3126 "src/parser_scan.c"
yy297:
			++cur;
			if ((lim - cur) < 3) CHECKEOF();;
			yych = *cur;
			switch (yych) {
			case '0':
			case '1':
			case '2':
			case '3':
			case '4':
			case '5':
			case '6':
			case '7':
			case '8':
			case '9':
			case 'A':
			case 'B':
			case 'C':
			case 'D':
			case 'E':
			case 'F':
			case 'a':
			case 'b':
			case 'c':
			case 'd':
			case 'e':
			case 'f':	goto yy297;
			case 'P':
			case 'p':	goto yy126;
			default:	goto yy114;
			}
yy299:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'Y':
			case 'y':	goto yy377;
			default:	goto yy62;
			}
yy300:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'A':
			case 'a':	goto yy379;
			default:	goto yy62;
			}
yy301:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'V':
			case 'v':	goto yy380;
			default:	goto yy62;
			}
yy302:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'A':
			case 'a':	goto yy381;
			case 'B':
			case 'b':	goto yy382;
			case 'O':
			case 'o':	goto yy383;
			default:	goto yy62;
			}
yy303:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'T':
			case 't':	goto yy384;
			default:	goto yy62;
			}
yy304:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'N':
			case 'n':	goto yy386;
			default:	goto yy62;
			}
yy305:
			yyaccept = 13;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy306;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy306:
#line 197 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_ELIF); goto start; }
#line 3284 "src/parser_scan.c"
yy307:
			yyaccept = 14;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy308;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy308:
#line 196 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_ELSE); goto start; }
#line 3359 "src/parser_scan.c"
yy309:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'F':
			case 'f':	goto yy387;
			default:	goto yy62;
			}
yy310:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'R':
			case 'r':	goto yy389;
			default:	goto yy62;
			}
yy311:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'E':
			case 'e':	goto yy391;
			default:	goto yy62;
			}
yy312:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'T':
			case 't':	goto yy393;
			default:	goto yy62;
			}
yy313:
			yyaccept = 15;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy314;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy314:
#line 224 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_FREE); goto start; }
#line 3466 "src/parser_scan.c"
yy315:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'T':
			case 't':	goto yy394;
			default:	goto yy62;
			}
yy316:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'F':
			case 'f':	goto yy395;
			default:	goto yy62;
			}
yy317:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'E':
			case 'e':	goto yy397;
			default:	goto yy62;
			}
yy318:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'U':
			case 'u':	goto yy398;
			default:	goto yy62;
			}
yy319:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'A':
			case 'a':	goto yy399;
			default:	goto yy62;
			}
yy320:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'D':
			case 'd':	goto yy400;
			default:	goto yy62;
			}
yy321:
			yyaccept = 16;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy322;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy322:
#line 208 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_NULL); goto start; }
#line 3589 "src/parser_scan.c"
yy323:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'C':
			case 'c':	goto yy402;
			default:	goto yy62;
			}
yy324:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'A':
			case 'a':	goto yy403;
			default:	goto yy62;
			}
yy325:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'V':
			case 'v':	goto yy404;
			default:	goto yy62;
			}
yy326:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case '_':	goto yy405;
			default:	goto yy62;
			}
yy327:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'A':
			case 'a':	goto yy406;
			default:	goto yy62;
			}
yy328:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'R':
			case 'r':	goto yy407;
			default:	goto yy62;
			}
yy329:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'I':
			case 'i':	goto yy408;
			default:	goto yy62;
			}
yy330:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'N':
			case 'n':	goto yy409;
			default:	goto yy62;
			}
yy331:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'E':
			case 'e':	goto yy410;
			default:	goto yy62;
			}
yy332:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'A':
			case 'a':	goto yy411;
			default:	goto yy62;
			}
yy333:
			yyaccept = 17;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy334;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy334:
#line 225 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_TEMP); goto start; }
#line 3743 "src/parser_scan.c"
yy335:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'R':
			case 'r':	goto yy412;
			default:	goto yy62;
			}
yy336:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'O':
			case 'o':	goto yy413;
			default:	goto yy62;
			}
yy337:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'L':
			case 'l':	goto yy414;
			default:	goto yy62;
			}
yy338:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'N':
			case 'n':	goto yy415;
			default:	goto yy62;
			}
yy339:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'B':
			case 'b':	goto yy416;
			default:	goto yy62;
			}
yy340:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'T':
			case 't':	goto yy417;
			default:	goto yy62;
			}
yy341:
			yyaccept = 18;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy342;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy342:
#line 206 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_TRUE); goto start; }
#line 3866 "src/parser_scan.c"
yy343:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'F':
			case 'f':	goto yy418;
			default:	goto yy62;
			}
yy344:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'I':
			case 'i':	goto yy420;
			default:	goto yy62;
			}
yy345:
			yyaccept = 19;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy346;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy346:
#line 234 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_ZVAL); goto start; }
#line 3957 "src/parser_scan.c"
yy347:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'm':	goto yy421;
			default:	goto yy62;
			}
yy348:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 't':	goto yy423;
			default:	goto yy62;
			}
yy349:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 't':	goto yy424;
			default:	goto yy62;
			}
yy350:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'l':	goto yy272;
			default:	goto yy62;
			}
yy351:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 's':	goto yy425;
			default:	goto yy62;
			}
yy352:
			yyaccept = 20;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy353;
			case 'V':
			case 'v':	goto yy380;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy353:
#line 184 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_BOOL); goto start; }
#line 4069 "src/parser_scan.c"
yy354:
			yyaccept = 21;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy355;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy355:
#line 185 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_CHAR); goto start; }
#line 4144 "src/parser_scan.c"
yy356:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 't':	goto yy426;
			default:	goto yy62;
			}
yy357:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'l':	goto yy428;
			default:	goto yy62;
			}
yy358:
			yyaccept = 22;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy359;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy359:
#line 181 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_ENUM); goto start; }
#line 4233 "src/parser_scan.c"
yy360:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'T':	goto yy393;
			case 't':	goto yy429;
			default:	goto yy62;
			}
yy361:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'n':	goto yy431;
			default:	goto yy62;
			}
yy362:
			yyaccept = 23;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy363;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy363:
#line 177 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_LINE); goto start; }
#line 4323 "src/parser_scan.c"
yy364:
			yyaccept = 24;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy365;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy365:
#line 188 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_LONG); goto start; }
#line 4398 "src/parser_scan.c"
yy366:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'm':	goto yy432;
			default:	goto yy62;
			}
yy367:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 't':	goto yy433;
			default:	goto yy62;
			}
yy368:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'e':	goto yy435;
			default:	goto yy62;
			}
yy369:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'o':	goto yy436;
			default:	goto yy62;
			}
yy370:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'c':	goto yy437;
			default:	goto yy62;
			}
yy371:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'd':	goto yy438;
			default:	goto yy62;
			}
yy372:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'n':	goto yy439;
			default:	goto yy62;
			}
yy373:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'g':	goto yy441;
			default:	goto yy62;
			}
yy374:
			yyaccept = 25;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy375;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy375:
#line 183 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_VOID); goto start; }
#line 4529 "src/parser_scan.c"
yy376:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 't':	goto yy442;
			default:	goto yy62;
			}
yy377:
			yyaccept = 26;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy378;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy378:
#line 212 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_ARRAY); goto start; }
#line 4611 "src/parser_scan.c"
yy379:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'L':
			case 'l':	goto yy443;
			default:	goto yy62;
			}
yy380:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'A':
			case 'a':	goto yy445;
			default:	goto yy62;
			}
yy381:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'B':
			case 'b':	goto yy446;
			default:	goto yy62;
			}
yy382:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'A':
			case 'a':	goto yy447;
			default:	goto yy62;
			}
yy383:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'C':
			case 'c':	goto yy448;
			default:	goto yy62;
			}
yy384:
			yyaccept = 27;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy385;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy385:
#line 235 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_COUNT); goto start; }
#line 4726 "src/parser_scan.c"
yy386:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'E':
			case 'e':	goto yy450;
			default:	goto yy62;
			}
yy387:
			yyaccept = 28;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy388;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy388:
#line 198 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_ENDIF); goto start; }
#line 4809 "src/parser_scan.c"
yy389:
			yyaccept = 29;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy390;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy390:
#line 203 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_ERROR); goto start; }
#line 4884 "src/parser_scan.c"
yy391:
			yyaccept = 30;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy392;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy392:
#line 207 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_FALSE); goto start; }
#line 4959 "src/parser_scan.c"
yy393:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'V':
			case 'v':	goto yy452;
			default:	goto yy62;
			}
yy394:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'I':
			case 'i':	goto yy453;
			default:	goto yy62;
			}
yy395:
			yyaccept = 31;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy396;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy396:
#line 194 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_IFDEF); goto start; }
#line 5050 "src/parser_scan.c"
yy397:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'F':
			case 'f':	goto yy454;
			default:	goto yy62;
			}
yy398:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'D':
			case 'd':	goto yy456;
			default:	goto yy62;
			}
yy399:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'L':
			case 'l':	goto yy457;
			default:	goto yy62;
			}
yy400:
			yyaccept = 32;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy401;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy401:
#line 209 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_MIXED); goto start; }
#line 5149 "src/parser_scan.c"
yy402:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'T':
			case 't':	goto yy459;
			default:	goto yy62;
			}
yy403:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'L':
			case 'l':	goto yy461;
			default:	goto yy62;
			}
yy404:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'A':
			case 'a':	goto yy463;
			default:	goto yy62;
			}
yy405:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'A':
			case 'a':	goto yy464;
			default:	goto yy62;
			}
yy406:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'S':
			case 's':	goto yy465;
			default:	goto yy62;
			}
yy407:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'N':
			case 'n':	goto yy466;
			default:	goto yy62;
			}
yy408:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'C':
			case 'c':	goto yy468;
			default:	goto yy62;
			}
yy409:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'G':
			case 'g':	goto yy470;
			default:	goto yy62;
			}
yy410:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'N':
			case 'n':	goto yy472;
			default:	goto yy62;
			}
yy411:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'L':
			case 'l':	goto yy474;
			default:	goto yy62;
			}
yy412:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'R':
			case 'r':	goto yy476;
			default:	goto yy62;
			}
yy413:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'O':
			case 'o':	goto yy477;
			default:	goto yy62;
			}
yy414:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'O':
			case 'o':	goto yy478;
			default:	goto yy62;
			}
yy415:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'T':
			case 't':	goto yy479;
			default:	goto yy62;
			}
yy416:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'J':
			case 'j':	goto yy481;
			default:	goto yy62;
			}
yy417:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'R':
			case 'r':	goto yy482;
			default:	goto yy62;
			}
yy418:
			yyaccept = 33;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy419;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy419:
#line 201 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_UNDEF); goto start; }
#line 5352 "src/parser_scan.c"
yy420:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'N':
			case 'n':	goto yy483;
			default:	goto yy62;
			}
yy421:
			yyaccept = 34;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy422;
			case '\\':	goto yy147;
			case '_':	goto yy484;
			default:	goto yy61;
			}
yy422:
#line 174 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_CPP_ASM); goto start; }
#line 5436 "src/parser_scan.c"
yy423:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'r':	goto yy485;
			default:	goto yy62;
			}
yy424:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'e':	goto yy486;
			default:	goto yy62;
			}
yy425:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 't':	goto yy487;
			default:	goto yy62;
			}
yy426:
			yyaccept = 35;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy427;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy427:
#line 182 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_CONST); goto start; }
#line 5532 "src/parser_scan.c"
yy428:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'e':	goto yy488;
			default:	goto yy62;
			}
yy429:
			yyaccept = 36;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy430;
			case 'V':
			case 'v':	goto yy452;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy430:
#line 189 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_FLOAT); goto start; }
#line 5616 "src/parser_scan.c"
yy431:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'e':	goto yy490;
			default:	goto yy62;
			}
yy432:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'a':	goto yy492;
			default:	goto yy62;
			}
yy433:
			yyaccept = 37;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy434;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy434:
#line 186 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_SHORT); goto start; }
#line 5705 "src/parser_scan.c"
yy435:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'd':	goto yy494;
			default:	goto yy62;
			}
yy436:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'f':	goto yy496;
			default:	goto yy62;
			}
yy437:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 't':	goto yy498;
			default:	goto yy62;
			}
yy438:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'e':	goto yy500;
			default:	goto yy62;
			}
yy439:
			yyaccept = 38;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy440;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy440:
#line 180 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_UNION); goto start; }
#line 5808 "src/parser_scan.c"
yy441:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'n':	goto yy501;
			default:	goto yy62;
			}
yy442:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'i':	goto yy502;
			default:	goto yy62;
			}
yy443:
			yyaccept = 39;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy444;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy444:
#line 232 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_ARRVAL); goto start; }
#line 5897 "src/parser_scan.c"
yy445:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'L':
			case 'l':	goto yy503;
			default:	goto yy62;
			}
yy446:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'L':
			case 'l':	goto yy505;
			default:	goto yy62;
			}
yy447:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'C':
			case 'c':	goto yy506;
			default:	goto yy62;
			}
yy448:
			yyaccept = 40;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy449;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy449:
#line 236 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_CALLOC); goto start; }
#line 5996 "src/parser_scan.c"
yy450:
			yyaccept = 41;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy451;
			case 'D':
			case 'd':	goto yy507;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy451:
#line 199 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_DEFINE); goto start; }
#line 6073 "src/parser_scan.c"
yy452:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'A':
			case 'a':	goto yy509;
			default:	goto yy62;
			}
yy453:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'O':
			case 'o':	goto yy510;
			default:	goto yy62;
			}
yy454:
			yyaccept = 42;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy455;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy455:
#line 195 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_IFNDEF); goto start; }
#line 6164 "src/parser_scan.c"
yy456:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'E':
			case 'e':	goto yy511;
			default:	goto yy62;
			}
yy457:
			yyaccept = 43;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy458;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy458:
#line 229 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_INTVAL); goto start; }
#line 6247 "src/parser_scan.c"
yy459:
			yyaccept = 44;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy460;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy460:
#line 213 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_OBJECT); goto start; }
#line 6322 "src/parser_scan.c"
yy461:
			yyaccept = 45;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy462;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy462:
#line 233 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_OBJVAL); goto start; }
#line 6397 "src/parser_scan.c"
yy463:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'L':
			case 'l':	goto yy513;
			default:	goto yy62;
			}
yy464:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'S':
			case 's':	goto yy515;
			default:	goto yy62;
			}
yy465:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'S':
			case 's':	goto yy516;
			default:	goto yy62;
			}
yy466:
			yyaccept = 46;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy467;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy467:
#line 222 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_RETURN); goto start; }
#line 6496 "src/parser_scan.c"
yy468:
			yyaccept = 47;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy469;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy469:
#line 215 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_STATIC); goto start; }
#line 6571 "src/parser_scan.c"
yy470:
			yyaccept = 48;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy471;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy471:
#line 211 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_STRING); goto start; }
#line 6646 "src/parser_scan.c"
yy472:
			yyaccept = 49;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy473;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy473:
#line 226 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_STRLEN); goto start; }
#line 6721 "src/parser_scan.c"
yy474:
			yyaccept = 50;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy475;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy475:
#line 227 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_STRVAL); goto start; }
#line 6796 "src/parser_scan.c"
yy476:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'A':
			case 'a':	goto yy517;
			default:	goto yy62;
			}
yy477:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'L':
			case 'l':	goto yy518;
			default:	goto yy62;
			}
yy478:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'A':
			case 'a':	goto yy520;
			default:	goto yy62;
			}
yy479:
			yyaccept = 51;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy480;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy480:
#line 240 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_TO_INT); goto start; }
#line 6895 "src/parser_scan.c"
yy481:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'E':
			case 'e':	goto yy521;
			default:	goto yy62;
			}
yy482:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'I':
			case 'i':	goto yy522;
			default:	goto yy62;
			}
yy483:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'G':
			case 'g':	goto yy523;
			default:	goto yy62;
			}
yy484:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case '_':	goto yy525;
			default:	goto yy62;
			}
yy485:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'i':	goto yy526;
			default:	goto yy62;
			}
yy486:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'n':	goto yy527;
			default:	goto yy62;
			}
yy487:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'r':	goto yy528;
			default:	goto yy62;
			}
yy488:
			yyaccept = 52;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy489;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy489:
#line 190 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_DOUBLE); goto start; }
#line 7022 "src/parser_scan.c"
yy490:
			yyaccept = 53;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy491;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy491:
#line 171 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_CPP_INLINE); goto start; }
#line 7097 "src/parser_scan.c"
yy492:
			yyaccept = 54;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy493;
			case '\\':	goto yy147;
			default:	goto yy529;
			}
yy493:
#line 169 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_PRAGMA); goto start; }
#line 7172 "src/parser_scan.c"
yy494:
			yyaccept = 55;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy495;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy495:
#line 192 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_SIGNED); goto start; }
#line 7247 "src/parser_scan.c"
yy496:
			yyaccept = 56;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy497;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy497:
#line 176 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_SIZEOF); goto start; }
#line 7322 "src/parser_scan.c"
yy498:
			yyaccept = 57;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy499;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy499:
#line 179 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_STRUCT); goto start; }
#line 7397 "src/parser_scan.c"
yy500:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'f':	goto yy531;
			default:	goto yy62;
			}
yy501:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'e':	goto yy533;
			default:	goto yy62;
			}
yy502:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'l':	goto yy534;
			default:	goto yy62;
			}
yy503:
			yyaccept = 58;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy504;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy504:
#line 231 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_BOOLVAL); goto start; }
#line 7493 "src/parser_scan.c"
yy505:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'E':
			case 'e':	goto yy535;
			default:	goto yy62;
			}
yy506:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'K':
			case 'k':	goto yy537;
			default:	goto yy62;
			}
yy507:
			yyaccept = 59;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy508;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy508:
#line 200 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_DEFINED); goto start; }
#line 7584 "src/parser_scan.c"
yy509:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'L':
			case 'l':	goto yy539;
			default:	goto yy62;
			}
yy510:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'N':
			case 'n':	goto yy541;
			default:	goto yy62;
			}
yy511:
			yyaccept = 60;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy512;
			case '\\':	goto yy147;
			case '_':	goto yy543;
			default:	goto yy61;
			}
yy512:
#line 204 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_INCLUDE); goto start; }
#line 7676 "src/parser_scan.c"
yy513:
			yyaccept = 61;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy514;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy514:
#line 228 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_PATHVAL); goto start; }
#line 7751 "src/parser_scan.c"
yy515:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'S':
			case 's':	goto yy544;
			default:	goto yy62;
			}
yy516:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'E':
			case 'e':	goto yy545;
			default:	goto yy62;
			}
yy517:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'Y':
			case 'y':	goto yy546;
			default:	goto yy62;
			}
yy518:
			yyaccept = 62;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy519;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy519:
#line 242 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_TO_BOOL); goto start; }
#line 7850 "src/parser_scan.c"
yy520:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'T':
			case 't':	goto yy548;
			default:	goto yy62;
			}
yy521:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'C':
			case 'c':	goto yy550;
			default:	goto yy62;
			}
yy522:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'N':
			case 'n':	goto yy551;
			default:	goto yy62;
			}
yy523:
			yyaccept = 63;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy524;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy524:
#line 202 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_WARNING); goto start; }
#line 7949 "src/parser_scan.c"
yy525:
			yyaccept = 34;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy422;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy526:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'b':	goto yy552;
			default:	goto yy62;
			}
yy527:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 's':	goto yy553;
			default:	goto yy62;
			}
yy528:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'i':	goto yy554;
			default:	goto yy62;
			}
yy529:
			yyaccept = 3;
			mrk = ++cur;
			if (lim <= cur) CHECKEOF();;
			yych = *cur;
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy55;
			case '\\':	goto yy147;
			case 'o':	goto yy555;
			default:	goto yy529;
			}
yy531:
			yyaccept = 64;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy532;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy532:
#line 178 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_TYPEDEF); goto start; }
#line 8190 "src/parser_scan.c"
yy533:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'd':	goto yy557;
			default:	goto yy62;
			}
yy534:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'e':	goto yy559;
			default:	goto yy62;
			}
yy535:
			yyaccept = 65;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy536;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy536:
#line 210 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_CALLABLE); goto start; }
#line 8279 "src/parser_scan.c"
yy537:
			yyaccept = 66;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy538;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy538:
#line 214 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_CALLBACK); goto start; }
#line 8354 "src/parser_scan.c"
yy539:
			yyaccept = 67;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy540;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy540:
#line 230 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_FLOATVAL); goto start; }
#line 8429 "src/parser_scan.c"
yy541:
			yyaccept = 68;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy542;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy542:
#line 216 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_FUNCTION); goto start; }
#line 8504 "src/parser_scan.c"
yy543:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'N':
			case 'n':	goto yy561;
			default:	goto yy62;
			}
yy544:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'E':
			case 'e':	goto yy562;
			default:	goto yy62;
			}
yy545:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'R':
			case 'r':	goto yy563;
			default:	goto yy62;
			}
yy546:
			yyaccept = 69;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy547;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy547:
#line 238 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_TO_ARRAY); goto start; }
#line 8603 "src/parser_scan.c"
yy548:
			yyaccept = 70;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy549;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy549:
#line 241 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_TO_FLOAT); goto start; }
#line 8678 "src/parser_scan.c"
yy550:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'T':
			case 't':	goto yy564;
			default:	goto yy62;
			}
yy551:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'G':
			case 'g':	goto yy566;
			default:	goto yy62;
			}
yy552:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'u':	goto yy568;
			default:	goto yy62;
			}
yy553:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'i':	goto yy569;
			default:	goto yy62;
			}
yy554:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'c':	goto yy570;
			default:	goto yy62;
			}
yy555:
			yyaccept = 3;
			mrk = ++cur;
			if (lim <= cur) CHECKEOF();;
			yych = *cur;
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy55;
			case '\\':	goto yy147;
			case 'n':	goto yy571;
			case 'o':	goto yy555;
			default:	goto yy529;
			}
yy557:
			yyaccept = 71;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy558;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy558:
#line 191 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_UNSIGNED); goto start; }
#line 8865 "src/parser_scan.c"
yy559:
			yyaccept = 72;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy560;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy560:
#line 175 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_VOLATILE); goto start; }
#line 8940 "src/parser_scan.c"
yy561:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'E':
			case 'e':	goto yy572;
			default:	goto yy62;
			}
yy562:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'R':
			case 'r':	goto yy573;
			default:	goto yy62;
			}
yy563:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'T':
			case 't':	goto yy574;
			default:	goto yy62;
			}
yy564:
			yyaccept = 73;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy565;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy565:
#line 237 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_TO_OBJECT); goto start; }
#line 9039 "src/parser_scan.c"
yy566:
			yyaccept = 74;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy567;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy567:
#line 239 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_TO_STRING); goto start; }
#line 9114 "src/parser_scan.c"
yy568:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 't':	goto yy576;
			default:	goto yy62;
			}
yy569:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'o':	goto yy577;
			default:	goto yy62;
			}
yy570:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 't':	goto yy578;
			default:	goto yy62;
			}
yy571:
			yyaccept = 3;
			mrk = ++cur;
			if (lim <= cur) CHECKEOF();;
			yych = *cur;
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy55;
			case '\\':	goto yy147;
			case 'c':	goto yy580;
			case 'o':	goto yy555;
			default:	goto yy529;
			}
yy572:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'X':
			case 'x':	goto yy581;
			default:	goto yy62;
			}
yy573:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'T':
			case 't':	goto yy582;
			default:	goto yy62;
			}
yy574:
			yyaccept = 75;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy575;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy575:
#line 220 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_PRE_ASSERT); goto start; }
#line 9301 "src/parser_scan.c"
yy576:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'e':	goto yy584;
			default:	goto yy62;
			}
yy577:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'n':	goto yy585;
			default:	goto yy62;
			}
yy578:
			yyaccept = 76;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy579;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy579:
#line 172 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_CPP_RESTRICT); goto start; }
#line 9390 "src/parser_scan.c"
yy580:
			yyaccept = 3;
			mrk = ++cur;
			if (lim <= cur) CHECKEOF();;
			yych = *cur;
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy55;
			case '\\':	goto yy147;
			case 'e':	goto yy586;
			case 'o':	goto yy555;
			default:	goto yy529;
			}
yy581:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'T':
			case 't':	goto yy588;
			default:	goto yy62;
			}
yy582:
			yyaccept = 77;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy583;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy583:
#line 221 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_POST_ASSERT); goto start; }
#line 9548 "src/parser_scan.c"
yy584:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case '_':	goto yy590;
			default:	goto yy62;
			}
yy585:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case '_':	goto yy591;
			default:	goto yy62;
			}
yy586:
			yyaccept = 78;
			mrk = ++cur;
			if (lim <= cur) CHECKEOF();;
			yych = *cur;
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy587;
			case '\\':	goto yy147;
			case 'o':	goto yy555;
			default:	goto yy529;
			}
yy587:
#line 170 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_PRAGMA_ONCE); goto start; }
#line 9640 "src/parser_scan.c"
yy588:
			yyaccept = 79;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy589;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy589:
#line 205 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_INCLUDE_NEXT); goto start; }
#line 9715 "src/parser_scan.c"
yy590:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case '_':	goto yy592;
			default:	goto yy62;
			}
yy591:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case '_':	goto yy593;
			default:	goto yy62;
			}
yy592:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case '\t':
			case '\f':
			case ' ':	goto yy595;
			case '(':	goto yy597;
			default:	goto yy62;
			}
yy593:
			yyaccept = 80;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy594;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy594:
#line 173 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_CPP_EXTENSION); goto start; }
#line 9814 "src/parser_scan.c"
yy595:
			++cur;
			if ((lim - cur) < 2) CHECKEOF();;
			yych = *cur;
			switch (yych) {
			case '\t':
			case '\f':
			case ' ':	goto yy595;
			case '(':	goto yy597;
			default:	goto yy114;
			}
yy597:
			yych = *++cur;
			switch (yych) {
			case '(':	goto yy598;
			default:	goto yy114;
			}
yy598:
			++cur;
#line 247 "src/parser_scan.re"
			{ parens = 2; goto cpp_attribute; }
#line 9836 "src/parser_scan.c"
		}
#line 253 "src/parser_scan.re"


	character: ;
		
#line 9843 "src/parser_scan.c"
		{
			unsigned char yych;
			if (lim <= cur) CHECKEOF();;
			yych = *cur;
			switch (yych) {
			case '\n':
			case '\r':	goto yy604;
			case '\'':	goto yy606;
			case '\\':	goto yy608;
			default:	goto yy602;
			}
yy602:
			++cur;
#line 271 "src/parser_scan.re"
			{ escaped = false; goto character; }
#line 9859 "src/parser_scan.c"
yy604:
			++cur;
#line 258 "src/parser_scan.re"
			{ NEWLINE(); goto character; }
#line 9864 "src/parser_scan.c"
yy606:
			++cur;
#line 260 "src/parser_scan.re"
			{
			if (escaped) {
				escaped = false;
				goto character;
			}
			cur -= 1;
			NEWTOKEN(PSI_T_QUOTED_CHAR);
			cur += 1;
			token->flags = char_width;
			goto start;
		}
#line 9879 "src/parser_scan.c"
yy608:
			++cur;
#line 259 "src/parser_scan.re"
			{ escaped = !escaped;  goto character; }
#line 9884 "src/parser_scan.c"
		}
#line 273 "src/parser_scan.re"


	string: ;
		
#line 9891 "src/parser_scan.c"
		{
			unsigned char yych;
			if (lim <= cur) CHECKEOF();;
			yych = *cur;
			switch (yych) {
			case '\n':
			case '\r':	goto yy614;
			case '"':	goto yy616;
			case '\\':	goto yy618;
			default:	goto yy612;
			}
yy612:
			++cur;
#line 291 "src/parser_scan.re"
			{ escaped = false; goto string; }
#line 9907 "src/parser_scan.c"
yy614:
			++cur;
#line 278 "src/parser_scan.re"
			{ NEWLINE(); goto string; }
#line 9912 "src/parser_scan.c"
yy616:
			++cur;
#line 280 "src/parser_scan.re"
			{
			if (escaped) {
				escaped = false;
				goto string;
			}
			cur -= 1;
			NEWTOKEN(PSI_T_QUOTED_STRING);
			cur += 1;
			token->flags = char_width;
			goto start;
		}
#line 9927 "src/parser_scan.c"
yy618:
			++cur;
#line 279 "src/parser_scan.re"
			{ escaped = !escaped; goto string; }
#line 9932 "src/parser_scan.c"
		}
#line 293 "src/parser_scan.re"


	comment: ;
		
#line 9939 "src/parser_scan.c"
		{
			unsigned char yych;
			if ((lim - cur) < 2) CHECKEOF();;
			yych = *cur;
			switch (yych) {
			case '\n':
			case '\r':	goto yy624;
			case '*':	goto yy626;
			default:	goto yy622;
			}
yy622:
			++cur;
yy623:
#line 300 "src/parser_scan.re"
			{ goto comment; }
#line 9955 "src/parser_scan.c"
yy624:
			++cur;
#line 298 "src/parser_scan.re"
			{ NEWLINE(); goto comment; }
#line 9960 "src/parser_scan.c"
yy626:
			yych = *++cur;
			switch (yych) {
			case '/':	goto yy627;
			default:	goto yy623;
			}
yy627:
			++cur;
#line 299 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_COMMENT); goto start; }
#line 9971 "src/parser_scan.c"
		}
#line 302 "src/parser_scan.re"


	comment_sl: ;
		
#line 9978 "src/parser_scan.c"
		{
			unsigned char yych;
			if (lim <= cur) CHECKEOF();;
			yych = *cur;
			switch (yych) {
			case '\n':
			case '\r':	goto yy633;
			default:	goto yy631;
			}
yy631:
			++cur;
#line 308 "src/parser_scan.re"
			{ goto comment_sl; }
#line 9992 "src/parser_scan.c"
yy633:
			++cur;
#line 307 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_COMMENT); tok = cur - 1; NEWTOKEN(PSI_T_EOL); NEWLINE(); goto start; }
#line 9997 "src/parser_scan.c"
		}
#line 310 "src/parser_scan.re"


	cpp_attribute: ;

		
#line 10005 "src/parser_scan.c"
		{
			unsigned char yych;
			if (lim <= cur) CHECKEOF();;
			yych = *cur;
			switch (yych) {
			case '\n':
			case '\r':	goto yy639;
			case '(':	goto yy641;
			case ')':	goto yy643;
			default:	goto yy637;
			}
yy637:
			++cur;
#line 319 "src/parser_scan.re"
			{ goto cpp_attribute; }
#line 10021 "src/parser_scan.c"
yy639:
			++cur;
#line 318 "src/parser_scan.re"
			{ NEWLINE(); goto cpp_attribute; }
#line 10026 "src/parser_scan.c"
yy641:
			++cur;
#line 316 "src/parser_scan.re"
			{ ++parens; goto cpp_attribute; }
#line 10031 "src/parser_scan.c"
yy643:
			++cur;
#line 317 "src/parser_scan.re"
			{ if (parens == 1) { NEWTOKEN(PSI_T_CPP_ATTRIBUTE); goto start; } else { --parens; goto cpp_attribute; } }
#line 10036 "src/parser_scan.c"
		}
#line 321 "src/parser_scan.re"

error: ;

	P->error(PSI_DATA(P), token, PSI_WARNING, "PSI syntax error: unexpected input (%d) '%.*s' at col %tu",
			token->type, token->text->len, token->text->val, tok - eol + 1);
	psi_plist_free(tokens);
	return NULL;

done: ;

	PSI_DEBUG_PRINT(P, "PSI: EOF cur=%p lim=%p\n", cur, lim);

	return tokens;
}
